class Components {
  int compNum;          // number of this component  
  int x;               // x,y coordinates of this object
  int y;              
  int compIdent;       // assigned component number, 1 is resoivoir, etc       
  PImage compImg;      // instance of image
  boolean moving;       // movement of image in progress
  int angleImg = 0; 
  int count;
  String compName = "";
 

  // constructor                           component num, ID number (type)
  Components(int posx, int posy, int size, int cNum, int iNum,
    String imageNameAsString) { 
    x = posx;
    y = posy;
    compIdent = iNum;
    compNum = cNum;
    compName = imageNameAsString;
    compImg = loadImage(imageNameAsString);    // load image as defined
    compImg.resize(size, 0); // optional       // resize 
}// constructor
 
  void setup(){
    setPortPositions();
  }
 
  void display() {
    count++;
    // played with rotating components
   //   angleImg++;
   //   count = 0;

  //    pushMatrix();
  //    translate(x+compImg.width/2,y+compImg.height/2); //x + compImg.width, y+ compImg.height);
  //    rotate(radians(angleImg));
  //    tint(255,0,0);
      image(compImg, x,y); // -compImg.width/2,-compImg.height/2);
 //    popMatrix();  
  }
  
  void portDisplay(int comp, Ports[] ports, int redValue){
    ports[comp*4].display(redValue); 
    ports[comp*4+1].display(redValue);
    ports[comp*4+2].display(redValue);
    ports[comp*4+3].display(redValue);
  }
  
  boolean getMoving(){
    return moving;
  }
  
  int getTimer(){
    return timerStart;
  }

  int getCompNum(){
    return compNum;
  }
  
  int getCompIdent(){
    return compIdent;
  }

 boolean mouseOver(){
    if (mouseX>x&&
      mouseY>y&&
      mouseX<x+compImg.width && 
      mouseY<y+compImg.height){
       textSize(20);
       fill(0, 102, 153);
       text(compName.substring(0,compName.length()-4),450,15); 
       return true;
      }
      else
        return false;
 }
 
  boolean ComponentsMousePressed(Ports[] ports) {    // check for mouse press on this object
    if (mouseX>x&&
      mouseY>y&&
      mouseX<x+compImg.width && 
      mouseY<y+compImg.height) 
      {   // each component can have 4 ports, port numbers based on this object's number.
      
      if (ports[compNum * 4].getHoseNum() ==-1 &&    // if no hoses connected, then can be moved.
          ports[compNum * 4+1].getHoseNum() ==-1 &&
          ports[compNum * 4+2].getHoseNum() ==-1 &&
          ports[compNum * 4+3].getHoseNum() ==-1 ){
          moving=true;                              // move is in progress
          return true;
          }
      else {
        return false;
        
       }
      }
      
      else { 
        cursor(ARROW); 
        return false;
         
      }
  }  // endMousePressed

 boolean checkConnected(Ports[] ports){
   if (ports[compNum * 4].getHoseNum() ==-1 &&    // if no hoses connected, then can be moved.
          ports[compNum * 4+1].getHoseNum() ==-1 &&
          ports[compNum * 4+2].getHoseNum() ==-1 &&
          ports[compNum * 4+3].getHoseNum() ==-1 ){
          return false;
          }
          return true;
 }
boolean ComponentsMouseReleased(PImage trash,int tx, int ty, Ports[] ports) {
   if (moving)
    {
      if(mouseX>tx&&
        mouseY>ty&&
        mouseX<tx+trash.width && 
        mouseY<ty+trash.height) {
          x =-100; y = -100;
          moving = false;
          cursor(ARROW);
          
          ports[compNum * 4].removePort(compNum);
          ports[compNum * 4 +1].removePort(compNum);
          ports[compNum * 4 +2].removePort(compNum);
          ports[compNum * 4 +3].removePort(compNum);
          return true;       // in trash?
      }
    }
    
    if (moving) {
    moving=false; 
    cursor(ARROW);    // finish moving on mouse release
    
    return false;
    }
    return false;

  }
 
  void mouseDragged() {
    if (moving) {
      x=int((mouseX-compImg.width/2) /10) * 10;  
      y=int((mouseY-compImg.height/2) /10) * 10;
      setPortPositions();
    }
  }

void setPortPositions(){                 
                  // Tee
    if (compIdent==0)
                 {
                  port[4*compNum+2].setPos(x+ compImg.width, y + (compImg.width) / 2 - 11); // right middle  
                  port[4*compNum+1].setPos(x+(compImg.width / 2)-6,y + compImg.height);     // bottom middle   
                  port[4*compNum+0].setPos(x - 13,y + (compImg.width) / 2-11);              // Left middle     
                  }                
                  // Reservior
     if (compIdent==1){
              //   port[4*compNum+0].setPos((compImg.width / 2)-20,compImg.height+2);      // Bottom Left    
              //   port[4*compNum+1].setPos((compImg.width / 2)-1,compImg.height+2);     // bottom Right   
              //   port[4*compNum+3].setPos(compImg.width, (compImg.width) / 2 - 21);  // Right top       
              //   }
                 
                  port[4*compNum+0].setPos(x+(compImg.width / 2)-20,y + compImg.height+2);      // Bottom Left    
                  port[4*compNum+1].setPos(x+(compImg.width / 2)-1,y + compImg.height+2);     // bottom Right   
                  port[4*compNum+3].setPos(x+ compImg.width, y + (compImg.width) / 2 - 24);  // Right top       
}
               //   Constant Displacement Pump
     if (compIdent==2){
                 port[4*compNum+1].setPos(x+(compImg.width),y + compImg.height/2-5);           // middle right     
                 port[4*compNum].setPos(x-13,y+compImg.height/2-5);                     // bottom left  
                 } 
                 
                 // Variable Displacement Pump
     if (compIdent==3){  
                 port[4*compNum].setPos(x-13,y + compImg.height/2 - 15);                   // left middle Top   
                 port[4*compNum+1].setPos(x -13, y + (compImg.height/2) / 2 +14);          // left middle bottom 
                 }

                 
                 // Pressure Regulator
      if (compIdent==4)
                 { 
                 port[4*compNum].setPos(x+20,y-13);                                       // Top middle      
                 port[4*compNum+2].setPos(x+(compImg.width),y + compImg.height-16);     // bottom right   
                 port[4*compNum+1].setPos(x-10,y + compImg.height-16);                  // bottom Left     
                 } 
                 
                 // Open-Center Selector Valve
  if (compIdent==5){  
                 port[4*compNum+2].setPos(x+(compImg.width / 2)-7,y-13);                    // Top middle to act     
                 port[4*compNum+3].setPos(x+(compImg.width / 2)-7,y + compImg.height+ 0);      // bottom middle   
                 port[4*compNum].setPos(x - 13,y + (compImg.width) / 2-14);               // Left middle     
                 port[4*compNum+1].setPos(x+ compImg.width, y + (compImg.width) / 2 - 14);  // right middle    
                 }

                 // Closed-Center Selector Valve
 if (compIdent==6){
                 port[4*compNum+2].setPos(x+(compImg.width / 2)-7,y-13);                    // Top middle to act     
                 port[4*compNum+3].setPos(x+(compImg.width / 2)-7,y + compImg.height + 0);      // bottom middle   
                 port[4*compNum].setPos(x - 13,y + (compImg.width) / 2-14);               // Left middle     
                 port[4*compNum+1].setPos(x+ compImg.width, y + (compImg.width) / 2-14);  // right middle    
                 } 
                 // Double Acting Actuator
  if (compIdent==7){
                 port[4*compNum].setPos(x+(compImg.width / 5)-7,y+compImg.height+1);        // bottom right      
                 port[4*compNum+1].setPos(x+(compImg.width / 2),y+ compImg.height+1);        // bottom left        
                 }
  
  if (compIdent==8){    // manual pump
                 port[4*compNum+1].setPos(x+(compImg.width),y + compImg.height/2-1);           // right      
                 port[4*compNum].setPos(x-13,y+compImg.height/2-1);                     // left middle  
                 }      

  if (compIdent==9){   // Accumulator
                 port[4*compNum].setPos(x+(compImg.width)/2-5,y - 13);                     // middle top    
                 } 
                 
   if (compIdent==10){   // relief valve
                 port[4*compNum].setPos(x+(compImg.width)/2-12,y +(compImg.height) + 1);           // middle bottom     
                 port[4*compNum+1].setPos(x+compImg.width,y+compImg.height/2-2);                     // top left  
                 }  

  if (compIdent==12){   // Pressure Gauge
                 port[4*compNum].setPos(x+(compImg.width)/2-7,y +(compImg.height) + 1);           // middle bottom     
                 }
  
                   // Shuttle Valve
   if (compIdent==13){
                 port[4*compNum+2].setPos(x+(compImg.width / 2)-8,y-13);                    // Top middle to act     
            //     port[4*compNum+3].setPos(x+(compImg.width / 2)+10,y + compImg.height);      // bottom middle   
                 port[4*compNum].setPos(x - 13,y + (compImg.height-25));               // Left middle     
              //   port[4*compNum+1].setPos(x+ compImg.width, y + (compImg.height-20));  // right middle    
                 } 
   if (compIdent==14){  // sequence valve
             //    port[4*compNum+2].setPos(x+(compImg.width / 2)-8,y-13);                    // Top middle to act     
                // port[4*compNum+3].setPos(x+25,y + compImg.height+0);      // bottom middle   
                 port[4*compNum].setPos(x - 13,y + (compImg.height/2)+0);               // Left middle     
                 port[4*compNum+1].setPos(x+ compImg.width, y + (compImg.height/2)+0);  // right middle    
                 }                 

   if (compIdent==15){  // priority valve
             //    port[4*compNum+2].setPos(x+(compImg.width / 2)-8,y-13);                    // Top middle to act     
            //     port[4*compNum+3].setPos(x+(compImg.width / 2)+10,y + compImg.height);      // bottom middle   
                 port[4*compNum].setPos(x - 13,y + (compImg.height/2)+-3);               // Left middle     
                 port[4*compNum+1].setPos(x+ compImg.width, y + (compImg.height/2)+-3);  // right middle    
                 }   

    if (compIdent==16){  // Check valve
             //    port[4*compNum+2].setPos(x+(compImg.width / 2)-8,y-13);                    // Top middle to act     
            //     port[4*compNum+3].setPos(x+(compImg.width / 2)+10,y + compImg.height);      // bottom middle   
                 port[4*compNum].setPos(x - 13,y + (compImg.height/2)-6);               // Left middle     
                 port[4*compNum+1].setPos(x+ compImg.width, y + (compImg.height/2)-6);  // right middle    
                 }
        if (compIdent==20){  // Check valve
             //    port[4*compNum+2].setPos(x+(compImg.width / 2)-8,y-13);                    // Top middle to act     
            //     port[4*compNum+3].setPos(x+(compImg.width / 2)+10,y + compImg.height);      // bottom middle   
                 port[4*compNum+1].setPos(x - 13,y + (compImg.height/2)-6);               // Left middle     
                 port[4*compNum].setPos(x+ compImg.width, y + (compImg.height/2)-6);  // right middle    
                 }
    if (compIdent==17){  // Filter
             //    port[4*compNum+2].setPos(x+(compImg.width / 2)-8,y-13);                    // Top middle to act     
            //     port[4*compNum+3].setPos(x+(compImg.width / 2)+10,y + compImg.height);      // bottom middle   
                 port[4*compNum].setPos(x - 13,y + (compImg.height/2)-15);               // Left middle     
                 port[4*compNum+1].setPos(x+ compImg.width, y + (compImg.height/2)-15);  // right middle    
                 }
 
     if (compIdent==19){  // Shutoff
             //    port[4*compNum+2].setPos(x+(compImg.width / 2)-8,y-13);                    // Top middle to act     
            //     port[4*compNum+3].setPos(x+(compImg.width / 2)+10,y + compImg.height);      // bottom middle   
                 port[4*compNum].setPos(x - 13,y + (compImg.height/2)-12);               // Left middle     
                 port[4*compNum+1].setPos(x+ compImg.width, y + (compImg.height/2)-12);  // right middle    
                 }
  port[4*compNum].setComp(compIdent);
  port[4*compNum+1].setComp(compIdent);
  port[4*compNum+2].setComp(compIdent);
  port[4*compNum+3].setComp(compIdent);
 
  }//method
}//class 
