class Hoses {
  // Created a new hose for parts of hoses being combined into a group.
  
  PShape hoseGroup, hose;      // Individual and total hose run for each
  
  boolean created= false;      // Keep track if it was started for displaying
  int lastX, lastY;            // position of last 
  boolean hold;                 // controls whether we are dragging (holding the mouse)
 
  int startComp=-1;    // Hose starts at which component
  int startPort=-1;    // Hose start on which port of component
  int endComp=-1;      // Hose ends at which component
  int endPort=-1;      // Hose ends at which port
  int startPortNum=-1;  // Hose starts at which connection of total
  int endPortNum=-1;    // Hose ends at which connection of total

  color hoseColor = color(16,190,243);
  // constructor
  Hoses() { 
    hoseGroup = createShape(GROUP); 
  }// constructor

  boolean visible(){
    return hoseGroup.isVisible();                  // return if hose is visible
  }
  
  void hide(){
    hoseGroup.setVisible(false);                    // set if visible
  }
  
  // Set and Get hose parameters
  void setStartComp(int val){
    startComp = val;
  }
 
  void setStartPort(int val){
    startPort = val;
  }
  
  void setEndComp(int val){
    endComp = val;
  }
  
  void setEndPort(int val){
    endPort = val;
  }
  
  void setStartPortNum(int val){
    startPortNum = val;
  }
  
  void setEndPortNum(int val){
    endPortNum = val;
  }
  
  int getStartComp(){
    return startComp;
  }
  
  int getStartPort(){
    return startPort;
  }
  
  int getStartCompNum(){
    return int(startPortNum/4);
  }
  
  int getEndComp(){
    return endComp;
  }
 
  int getEndCompNum(){
    return int(endPortNum/4);
  }
  
  
  int getEndPort(){
    return endPort;
  }
  
  int getStartPortNum(){
    return startPortNum;
  }
  
  int getEndPortNum(){
    return endPortNum;
  }
  
  boolean checkCompNum(int compNum)
  {
    if(getStartCompNum() == compNum) return true;
    if(getEndCompNum() == compNum) return true;
    return false;
  }
  
    boolean checkPortNum(int portNum)
  {
    if(getStartPortNum() == portNum) return true;
    if(getEndPortNum() == portNum) return true;
    return false;
  }
  
    boolean checkComp(int comp)
  {
    if(getStartComp() == comp) return true;
    if(getEndComp() == comp) return true;
    return false;
  }
  
    boolean checkPort(int port)
  {
    if(getStartPort() == port) return true;
    if(getEndPort() == port) return true;
    return false;
  }
  
    boolean checkCompPort(int comp, int port)
  {
    if ((getStartComp() == comp) && (getStartPort() == port || port == -1) && getStartComp() != 0) return true;
    if ((getEndComp() == comp)  && (getEndPort() == port || port == -1) && getEndComp() != 0) return true;
    return false;
  }
  
  boolean checkHoseComp(int nComp){
    if (int(startPortNum / 4) == nComp) return true;
    if (int(endPortNum / 4) == nComp) return true;
    return false;
  }
 
             // add a new hose section with a click
  void addHose(int startX, int startY,int endX,int endY){
    if (created == false){                                      // If no prior hose coordinates, start a new hose
      if (abs(endX - startX) > abs(endY - startY)){             // for 90 degrees, higher X or Y?
        hose = createShape(LINE,startX+1, startY, endX+1, startY);
        lastX = endX; lastY = startY;
      } else {
        hose = createShape(LINE,startX+1, startY, startX+1, endY);
        lastX = startX; lastY = endY;
        }
    }else{
      if (abs(endX - lastX) > abs(endY - lastY)){              // If hose started, add to last position
        hose = createShape(LINE,lastX+1, lastY, endX+1, lastY);
        lastX = endX;
      }else {
      hose = createShape(LINE,lastX+1, lastY, lastX+1, endY);
        lastY = endY;
      }
    }
    
    hose.setStroke(color(0,255,255));                           // medium gray hose
    hose.setStrokeWeight(6);                    // thichness
    
    hoseGroup.addChild(hose);                      // Add new section to total hose group
    created = true;                                // Flag as created
  } // end addHose
  
  void finish(color hColor){
    hoseColor = hColor;
    hoseGroup.disableStyle();                      // disable old hose style
    stroke(hColor);                           // blue, 1/2 transparent
    strokeWeight(6);
    shape(hoseGroup); 
   // display(); // Draw the final hose    
  } // end finish
  
  void display(){
   if (created == true){
    hoseGroup.disableStyle();                      // disable old hose style
    stroke(hoseColor);                           
    strokeWeight(6);
    shape(hoseGroup); 
                         // Draw portion or finished hose
   }
  } // end display
    
} // end class
